"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.Pane = Pane;
var _checkbox = _interopRequireDefault(require("antd/lib/checkbox"));
var _table = _interopRequireDefault(require("antd/lib/table"));
var _button = _interopRequireDefault(require("antd/lib/button"));
var React = _interopRequireWildcard(require("react"));
require("./pane.css");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function Pane(props) {
  var _React$useState = React.useState({}),
    injectInfo = _React$useState[0],
    setInjectInfo = _React$useState[1];
  var _React$useState2 = React.useState([]),
    dataSource = _React$useState2[0],
    setDataSource = _React$useState2[1];
  var workspace = props.pluginContext.workspace;
  var options = workspace.resourceTypeList.map(function (resource) {
    var _resource$editorViews;
    return {
      label: resource.description || resource.resourceName,
      value: resource.resourceName,
      children: (_resource$editorViews = resource.editorViews) === null || _resource$editorViews === void 0 ? void 0 : _resource$editorViews.map(function (view) {
        return {
          label: view.viewName + '视图',
          value: view.viewName
        };
      })
    };
  });
  options.unshift({
    label: '全局',
    value: 'global'
  });
  var updateConfig = React.useCallback(function (config) {
    var newDataSource = Object.entries(config).map(function (_ref) {
      var key = _ref[0],
        value = _ref[1];
      return {
        pluginName: key
      };
    }).filter(function (d) {
      return props.injectedPluginConfigMap[d.pluginName];
    });
    setDataSource(newDataSource);
    props.getInjectInfo().then(function (res) {
      setInjectInfo(res);
    });
  }, []);
  React.useEffect(function () {
    updateConfig(props.injectConfig.config);
    props.injectConfig.onChange(function (config) {
      updateConfig(config);
    });
  }, []);
  var injectedSetters = injectInfo.injectedSetters;
  if (!(dataSource !== null && dataSource !== void 0 && dataSource.length) && !(injectedSetters !== null && injectedSetters !== void 0 && injectedSetters.length)) {
    return /*#__PURE__*/React.createElement("div", {
      className: "inject-setting-panel-empty"
    }, /*#__PURE__*/React.createElement("div", {
      className: "inject-setting-panel-empty-title"
    }, "\u672A\u68C0\u6D4B\u5230\u8C03\u8BD5\u63D2\u4EF6/\u7EC4\u4EF6"));
  }
  return /*#__PURE__*/React.createElement("div", {
    className: "inject-setting-panel"
  }, /*#__PURE__*/React.createElement("span", {
    className: "inject-setting-panel-title"
  }, "\u8BBE\u8BA1\u5668\u63D2\u4EF6\uFF1A"), /*#__PURE__*/React.createElement("span", {
    style: {
      "float": 'right'
    }
  }, /*#__PURE__*/React.createElement(_button["default"], {
    size: "small",
    onClick: function onClick() {
      props.injectConfig.clearAll();
      props.injectConfig.save();
      window.location.reload();
    }
  }, "\u91CD\u7F6E\u63D2\u4EF6\u914D\u7F6E")), /*#__PURE__*/React.createElement(_table["default"], {
    className: "inject-setting-panel-table",
    dataSource: dataSource
  }, /*#__PURE__*/React.createElement(_table["default"].Column, {
    title: "\u63D2\u4EF6\u540D\u5B57",
    htmlTitle: "\u63D2\u4EF6",
    dataIndex: "pluginName"
  }), /*#__PURE__*/React.createElement(_table["default"].Column, {
    title: "\u8C03\u8BD5\u6CE8\u518C\u89C6\u56FE",
    dataIndex: "pluginName",
    cell: function cell(pluginName, index, record) {
      return /*#__PURE__*/React.createElement(React.Fragment, null, options.map(function (resource) {
        if (resource.children) {
          return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("span", {
            className: "inject-setting-panel-label"
          }, resource.label), resource.children.map(function (view) {
            return /*#__PURE__*/React.createElement(_checkbox["default"], {
              checked: props.injectConfig.get(pluginName, resource.value, view.value),
              onChange: function onChange(checked) {
                props.updateInjectConfig(record.pluginName, resource.value, view.value, checked);
              }
            }, view.label);
          }));
        }
        return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("span", {
          className: "inject-setting-panel-label"
        }, resource.label), /*#__PURE__*/React.createElement(_checkbox["default"], {
          checked: props.injectConfig.get(pluginName, resource.value),
          onChange: function onChange(checked) {
            props.updateInjectConfig(record.pluginName, resource.value, '', checked);
          }
        }));
      }));
    }
  })), /*#__PURE__*/React.createElement(InjectItem, {
    title: "Setter",
    injectItems: injectedSetters
  }));
}
function InjectItem(props) {
  if (!props.injectItems || !props.injectItems.length) {
    return null;
  }
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("span", {
    className: "inject-setting-panel-title"
  }, props.title, "\uFF1A"), /*#__PURE__*/React.createElement("div", {
    className: "inject-setting-panel-inject-item"
  }, props.injectItems && props.injectItems.map(function (item) {
    return /*#__PURE__*/React.createElement("span", null, item.name);
  })));
}